/*

 This library is copyrighted(C) 1999 by WeeSan Lee <weesan@employees.org>, 
 with all rights reserved.  

 This program is free software;  please feel free to redistribute it 
 and/or modify it under the terms of the GNU General Public License 
 (version 2) as published by the Free Software Foundation.  It is 
 distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
 without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 PARTICULAR PURPOSE.  See the GNU General Public License for more details.

 */

#if !defined(IDENT_OFF)
#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ >= 7)
static const char ident[] =
"@(#)$Id: debug.cc,v 1.1 2005/05/26 22:36:10 weesan Exp $";
#endif
#endif

#include "debug.h"

DebugRegistry *Debug::pcDebugRegistry[DEBUG_TOTAL];
int Debug::iTotal;

#ifdef DEBUG_DEBUG

class A {
    DEBUG_INIT();
public:
    A(void) {
	DEBUG("%s", __PRETTY_FUNCTION__);
    }
};

class B : public A {
    DEBUG_INIT();
public:
    B(void) {
	DEBUG("%s", __PRETTY_FUNCTION__);
    }
};

DEBUG_REGISTER(A);
DEBUG_REGISTER(B);

int main(void) {
    Debug::on("A");
    Debug::on("B");
    A a;
    B b;

    return (0);
}

#endif
