// $Id: packet.cc,v 1.2 2005/06/11 20:45:25 weesan Exp $

#include "packet.h"
#include "simulation.h"

DEBUG_REGISTER(Packet);

// Static variable
packet_id_t Packet::tNextId = 0;

Packet::Packet(node_id_t tSrc,
	       node_id_t tDst,
	       packet_type_t tType,
	       packet_type_t tSubType,
	       int iTTL,
	       seqno_t tSeqNo) :
    tId(nextId()),
    tSrc(tSrc),
    tDst(tDst),
    tType(tType),
    tSubType(tSubType),
    iTTL(iTTL),
    tSeqNo(tSeqNo),
    tTimeStamp(NOW()) {
    DEBUG("%d (%d, %d) created", id(), type(), subType());
}

Packet::Packet(const Packet &p) :
    tId(p.id()),
    tSrc(p.src()),
    tDst(p.dst()),
    tType(p.type()),
    tSubType(p.subType()),
    iTTL(p.ttl()),
    tSeqNo(p.seqNo()),
    tTimeStamp(p.timeStamp()) {
    DEBUG("%d (%d, %d) cloned", id(), type(), subType());
}
