// $Id: queue.h,v 1.1 2005/05/26 22:36:10 weesan Exp $

#ifndef QUEUE_H
#define QUEUE_H

#include <list>
#include "object.h"
#include "debug.h"

#define QUEUE_SIZE    16

using namespace std;

// Forward declaration
class Packet;

// Basic queue sink
class Queue : public Object {
private:
    int iMaxLen;
    
public:
    Queue(const char *pzcName = "QueueSink", int iMaxLen = 0) :
	Object(pzcName),
	iMaxLen(iMaxLen) {
    }
    int maxLen(void) const {
	return (iMaxLen);
    }
    virtual bool add(Packet *pcPacket);
};

class QueueDropTail : public Queue, public list<Packet *> {
    DEBUG_INIT();

public:
    QueueDropTail(int iMaxLen = QUEUE_SIZE) : Queue("QueueDropTail", iMaxLen) {
    }
    virtual bool add(Packet *pcPacket);
};

#endif // QUEUE_H
